<?php

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

$document =& JFactory::getDocument();
$document->addScript(JURI::root(true) . '/administrator/components/com_ajaxregister/assets/js/script.js');

/**
 * Captcha Field class for the Joomla Framework.
 */
class JFormFieldCaptcha extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'Captcha';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{

		$recaptcha_signup_url = recaptcha_get_signup_url($_SERVER['HTTP_HOST'], 'AJAX Register');
		$field = '<span style="float:left"><a href="'.$recaptcha_signup_url.'" target="_blank">'.JText::_('AR_CONFIG_GET_RECAPTCHA').'</a></span>';
		
		return $field;
	}
}

// reCAPTCHA functions

/**
 * Encodes the given data into a query string format
 * @param $data - array of string elements to be encoded
 * @return string - encoded request
 */
if (!function_exists('_recaptcha_qsencode')) {
	function _recaptcha_qsencode ($data) {
        $req = "";
        foreach ( $data as $key => $value )
                $req .= $key . '=' . urlencode( stripslashes($value) ) . '&';

        // Cut the last '&'
        $req=substr($req,0,strlen($req)-1);
        return $req;
	}
}

/**
 * gets a URL where the user can sign up for reCAPTCHA. If your application
 * has a configuration page where you enter a key, you should provide a link
 * using this function.
 * @param string $domain The domain where the page is hosted
 * @param string $appname The name of your application
 */
if (!function_exists('recaptcha_get_signup_url')) {
	function recaptcha_get_signup_url ($domain = null, $appname = null) {
		return "https://www.google.com/recaptcha/admin/create?" .  _recaptcha_qsencode (array ('domains' => $domain, 'app' => $appname));
	}
}