<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
/**
 * Script file of AJAX Register component
 */
class com_ajaxregisterInstallerScript
{
        /**
         * method to install the component
         *
         * @return void
         */
        function install($parent) 
        {
            $manifest = $parent->get("manifest");
            $parent = $parent->getParent();
            $source = $parent->getPath("source");
             
            $installer = new JInstaller();
			
			$installed = array();
            
            // Install plugins
            foreach($manifest->plugins->plugin as $plugin) {
                $attributes = $plugin->attributes();
                $plg = $source . DS . $attributes['folder'];
				$plugin = $attributes['plugin'];
				if ($installer->install($plg)) {
					$installed["$plugin"] = true;
				} else {
					$installed["$plugin"] = false;
				}
            }
            
            $db = JFactory::getDbo();
            $tableExtensions = $db->nameQuote("#__extensions");
            $columnElement   = $db->nameQuote("element");
            $columnType      = $db->nameQuote("type");
            $columnEnabled   = $db->nameQuote("enabled");
			
			if (isset($installed['ajaxregister']) && $installed['ajaxregister']) {
				// Enable plugins
				$db->setQuery(
					"UPDATE 
						$tableExtensions
					SET
						$columnEnabled=1
					WHERE
						$columnElement='ajaxregister'
					AND
						$columnType='plugin'"
				);
				
				$db->query();
				
				echo 'AJAX Register system plugin also installed and enabled<br /><br /><a href="index.php?option=com_ajaxregister">Proceeed to AJAX Register control panel</a>';
			}
            
        }
 
        /**
         * method to uninstall the component
         *
         * @return void
         */
        function uninstall($parent) 
        {			
			$db =& JFactory::getDBO();
            $tableExtensions = $db->nameQuote("#__extensions");
            $columnElement   = $db->nameQuote("element");
            $columnType      = $db->nameQuote("type");
					
			$db->setQuery(
				"SELECT extension_id FROM 
					$tableExtensions
				WHERE
					$columnElement='ajaxregister'
				AND
					$columnType='plugin'"
			);

			if ($id = $db->loadResult()) {
				// uninstall the plugin
				$installer = new JInstaller();
				$result	= $installer->uninstall( 'plugin', $id, 0 );
				if ($result) {
					echo 'AJAX Register system plugin also removed';
				} else {
					echo 'AJAX Register system plugin could not be removed<br />Please remove this plugin manually';
				}
			} else {
				echo 'AJAX Register system plugin could not be found';
			}
			
			// $parent is the class calling this method
			//echo '<p>' . JText::_('COM_AJAXREGISTER_UNINSTALL_TEXT') . '</p>';
        }
 
        /**
         * method to update the component
         *
         * @return void
         */
        function update($parent) 
        {
			// $parent is the class calling this method
			//echo '<p>' . JText::_('COM_AJAXREGISTER_UPDATE_TEXT') . '</p>';
        }
 
        /**
         * method to run before an install/update/uninstall method
         *
         * @return void
         */
        function preflight($type, $parent) 
        {
			// $parent is the class calling this method
			// $type is the type of change (install, update or discover_install)
			//echo '<p>' . JText::_('COM_AJAXREGISTER_PREFLIGHT_' . $type . '_TEXT') . '</p>';
        }
 
        /**
         * method to run after an install/update/uninstall method
         *
         * @return void
         */
        function postflight($type, $parent) 
        {
			// $parent is the class calling this method
			// $type is the type of change (install, update or discover_install)
			//echo '<p>' . JText::_('COM_AJAXREGISTER_POSTFLIGHT_' . $type . '_TEXT') . '</p>';
        }
}
