<?php
/*
* @package		AJAX Register
* @copyright	Copyright (C) 2009-2010 Emir Sakic, http://www.sakic.net. All rights reserved.
* @license		GNU/GPL, see LICENSE.TXT
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This header must not be removed. Additional contributions/changes
* may be added to this header as long as no information is deleted.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.tooltip');
?>

<script type="text/javascript">
/* <![CDATA[ */
window.addEvent('domready', function(){
	var params = {
		ajax: <?php echo $this->ajax; ?>,
		msg_type:  '<?php echo $this->msg_type; ?>'
	};
	var strings = {
		wait: '<?php echo JText::_( 'AJAXREG_PLEASE_WAIT' ); ?>',
		checking: '<?php echo JText::_( 'AJAXREG_CHECKING' ); ?>',
		username_taken: '<?php echo JText::_( 'AJAXREG_USERNAME_TAKEN' ); ?>',
		username_illegal: '<?php echo JText::_( 'AJAXREG_USERNAME_ILLEGAL' ); ?>',
		username_short: '<?php echo JText::_( 'AJAXREG_USERNAME_SHORT' ); ?>',
		username_empty: '<?php echo JText::_( 'AJAXREG_USERNAME_EMPTY' ); ?>',
		email_taken: '<?php echo JText::_( 'AJAXREG_EMAIL_TAKEN' ); ?>',
		email_illegal: '<?php echo JText::_( 'AJAXREG_EMAIL_ILLEGAL' ); ?>',
		emails_different: '<?php echo JText::_( 'AJAXREG_EMAILS_DIFFERENT' ); ?>',
		password_short: '<?php echo JText::_( 'AJAXREG_PASSWORD_SHORT' ); ?>',
		passwords_different: '<?php echo JText::_( 'AJAXREG_PASSWORDS_DIFFERENT' ); ?>',
		required: '<?php echo JText::_( 'AJAXREG_REQUIRED' ); ?>',
		warning: '<?php echo JText::_( 'AJAXREG_WARNING' ); ?>',
		register: '<?php echo JText::_('Register'); ?>',
<?php
	if (!empty($this->password_strength)) {
?>
		weak: '<?php echo JText::_( 'AJAXREG_WEAK' ); ?>',
		fair: '<?php echo JText::_( 'AJAXREG_FAIR' ); ?>',
		good: '<?php echo JText::_( 'AJAXREG_GOOD' ); ?>',
		strong: '<?php echo JText::_( 'AJAXREG_STRONG' ); ?>',
<?php
	}
?>
		captcha_wrong: '<?php echo JText::_( 'AJAXREG_CAPTCHA_WRONG' ); ?>',
		captcha_failed: '<?php echo JText::_( 'AJAXREG_CAPTCHA_FAILED' ); ?>',
		answer_wrong: '<?php echo JText::_( 'AJAXREG_ANSWER_WRONG' ); ?>'
	};
	var myFormValidation = new Validate('member-registration', {url: '<?php echo JURI::root().'index.php?option=com_users&task=ajax&tmpl=component'; ?>', params: params, strings: strings});
});
/* ]]> */
</script>

<?php
	if(isset($this->message)){
		$this->display('message');
	}
	
	$this->form->setValue('disclaimer', null, $this->disclaimer_text);
	
	// remove fields if needed
	if ($this->email_as_username) {
		$this->form->removeField('username');
	}
	if (!$this->email_confirm) {
		$this->form->removeField('email2');
	}
	if (!$this->display_disclaimer) {
		$this->form->removeField('disclaimer');
	}
	if (!$this->display_disclaimer_checkbox) {
		$this->form->removeField('accept');
	}
?>

<div class="registration<?php echo $this->params->get( 'pageclass_sfx' ); ?>">
<?php if ($this->params->get('show_page_heading')) : ?>
	<h1><?php echo $this->escape($this->params->get('page_heading')); ?></h1>
<?php endif; ?>

	<form action="<?php echo JRoute::_( 'index.php?option=com_users&task=registration.register' ); ?>" method="post" id="member-registration" class="form-validate"<?php echo $this->autocomplete_off ? ' autocomplete="off"' : ''; ?>>
<?php foreach ($this->form->getFieldsets() as $fieldset): // Iterate through the form fieldsets and display each one.?>
	<?php $fields = $this->form->getFieldset($fieldset->name);?>
	<?php if (count($fields)):?>
		<fieldset>
		<?php if (isset($fieldset->label)):// If the fieldset has a label set, display it as the legend.?>
			<legend><?php echo JText::_($fieldset->label);?></legend>
		<?php endif;?>
			<dl>
		<?php foreach($fields as $field):// Iterate through the fields in the set and display them.?>
			<?php if ($field->hidden):// If the field is hidden, just display the input.?>
				<?php echo $field->input;?>
			<?php else:?>
				<dt>
				<?php echo $field->label; ?>
				<?php if (!$field->required && (!$field->type == "spacer")): ?>
					<span class="optional"><?php echo JText::_('COM_USERS_OPTIONAL');?></span>
				<?php endif; ?>
				</dt>
				<dd><?php echo $field->input;
					// password strength
					if ($field->id=='jform_password1' && $this->password_strength) {
				?>
						<div class="ar_password_strength">
							<div class="ar_password_bar_container">
								<div id="jform_password1_bar" class="ar_password_bar"></div>
							</div>
							<div id="jform_password1_text" class="ar_password_text"></div>
						</div>
				<?php
					}
				?></dd>
			<?php endif;?>
		<?php endforeach;?>
		
		<?php if (!empty($this->question)): ?>
			<dt>
				<label id="answermsg" for="answer">
					<?php echo $this->question['text']; ?>
					<span class="star">&nbsp;*</span>
				</label>
			</dt>
			<dd>
				<input type="text" id="answer" name="answer_<?php echo $this->question['id']; ?>" class="required" size="40" />
			</dd>
		<?php elseif (!empty($this->recaptcha)): ?>
				<dt class="captcha">
					<script>
					var RecaptchaOptions = {
					   theme : '<?php echo $this->recaptcha_theme; ?>',
					   lang : '<?php echo $this->recaptcha_lang; ?>'
					};
					</script>
					<?php echo $this->recaptcha; ?>
				</dt>
		<?php elseif (!empty($this->captcha)): ?>
				<dt class="captcha">
					<label id="captcha-lbl" for="captcha">
						<img src="<?php echo $this->baseurl; ?>/tmp/<?php echo $this->captcha['file'];?>" alt="" id="captcha_img" />
						<span class="star">&nbsp;*</span>
					</label>
				</dt>
				<dd>
					<input type="text" id="captcha" name="<?php echo $this->captcha['id']; ?>" class="required" size="10" />
					<?php echo JText::_('AJAXREG_CAPTCHA'); ?>
				</dd>
		<?php endif;?>
			</dl>
		</fieldset>
	<?php endif;?>
<?php endforeach;?>

		<div>
			<button class="button validate" type="submit"><?php echo JText::_('JREGISTER'); ?></button>
	<?php if (!empty($this->clear)) : ?>
			&nbsp;<button class="button reset" type="reset"><?php echo JText::_('AJAXREG_CLEAR'); ?></button>
	<?php endif; ?>
		</div>
		
		<input type="hidden" name="option" value="com_users" />
		<input type="hidden" name="task" value="registration.register" />
		<?php echo JHTML::_( 'form.token' ); ?>
	</form>
</div>