<?php
/*
* @package		AJAX Register
* @copyright	Copyright (C) 2009-2010 Emir Sakic, http://www.sakic.net. All rights reserved.
* @license		GNU/GPL, see LICENSE.TXT
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This header must not be removed. Additional contributions/changes
* may be added to this header as long as no information is deleted.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

// import library dependencies
//jimport('joomla.application.component.helper');
jimport('joomla.application.component.controller');

class ARControllerDashboard extends JController
{
	/**
	 * Controller constructor
	 *
	 * @access	protected
	 * @return	void
	 * @since	1.0
	 */
	function __construct()
	{
		parent::__construct();
	}

	/**
	 * Display the dashboard
	 */
	function display()
	{
		global $mainframe;

		// verify the Ajaxregister plugin is installed and published
		if (!class_exists('plgSystemAJAXRegister')) {
			JError::raiseWarning(500, JText::_('AR_PLUGIN_MISSING'));
		}

		$document = &JFactory::getDocument();
		$document->addStyleSheet( JURI::base().'components/com_ajaxregister/media/css/default.css' );

		// Set the default view name and format from the Request
		$vFormat	= $document->getType();
		$lName		= JRequest::getWord( 'layout', 'default' );

		$view = &$this->getView( 'dashboard', $vFormat );

		$view->setLayout($lName);

		// push document object into the view
		$view->assignRef('document', $document);

		$view->display();

	}
}

?>