<?php

// no direct access
defined('_JEXEC') or die('Restricted access');

// import library dependencies
jimport('joomla.application.component.model');

class ARModelConfig extends JModel
{	
	/**
	 * Flag to indicate model state initialization.
	 *
	 * @access	protected
	 * @var		boolean
	 */
	var $__state_set		= null;

	/**
	 * Overridden method to get model state variables.
	 *
	 * @access	public
	 * @param	string	$property	Optional parameter name.
	 * @return	object	The property where specified, the state object where omitted.
	 * @since	1.0
	 */
	function getState($property = null)
	{
		// if the model state is uninitialized lets set some values we will need from the request.
		if (!$this->__state_set)
		{
			// load the component configuration parameters.
			$this->setState('config', JComponentHelper::getParams('com_ajaxregister'));

			$this->__state_set = true;
		}

		return parent::getState($property);
	}
	
	function getRequirements() {

		$config = $this->getState('config');
	 	$requirements = array();

		// builtin captcha requires the GD libraries
		$gd = new JObject();
		$gd->set('name', JText::_('AR_REQUIREMENT_GD'));
		$gd->set('fail_message', JText::_('AR_REQUIREMENT_GD_WARNING'));
		$gd->set('level', 'notice');
		$gd->set('value', is_callable('gd_info'));
		$requirements[] = $gd;
		if ($config->get('enable_captcha') && !$config->get('enable_recaptcha') && !$gd->get('value')) {
			JError::raiseWarning(500, JText::_('AR_REQUIREMENT_GD_WARNING'));
		} elseif (!$gd->get('value')) {
			JError::raiseNotice(500, JText::_('AR_REQUIREMENT_GD_NOTICE'));
		}

	 	// extra information about GD if we need it in the future
		if (is_callable('gd_info')) {
			$gd = gd_info();
			foreach ($gd as $k => $v)
			{
				// var_dump($k); var_dump($v);
			}
		}

		if ($config->get('enable_captcha') && !$config->get('enable_recaptcha')) {
			// builtin captcha requires that a media folder be writeable
			$captchaFolder = new JObject();
			$captchaFolder->set('name', JText::_('AR_REQUIREMENT_CAPTCHA_FOLDER'));
			$captchaFolder->set('fail_message', JText::_('AR_REQUIREMENT_CAPTCHA_FOLDER_NOTICE'));
			$captchaFolder->set('level', 'warning');
			$captchaFolder->set('value', is_writable(JPATH_SITE.DS.'tmp'));
			$requirements[] = $captchaFolder;
			if (!$captchaFolder->get('value')) {
				JError::raiseNotice(500, JText::sprintf('AR_REQUIREMENT_CAPTCHA_FOLDER_NOTICE', JPATH_SITE.DS.'tmp'));
			}
		}

	 	return $requirements;
	}

	/**
	 * Method to save the component configuration
	 *
	 * @access	public
	 * @return	boolean	True on success
	 * @since	1.0
	 */
	function save()
	{
		// initialize variables.
		$table			= &JTable::getInstance('component');
		$params 		= JRequest::getVar('params', array(), 'post', 'array');
		$row			= array();
		$row['option']	= 'com_ajaxregister';
		$row['params']	= $params;
		
		if (isset($row['params']['redirect_url'])) {
			$row['params']['redirect_url'] = str_replace(JURI::root(),'',$row['params']['redirect_url']);
		}

		// load the component data for com_ajaxregister
		if (!$table->loadByOption('com_ajaxregister')) {
			$this->setError($table->getError());
			return false;
		}

		// bind the new values
		$table->bind($row);

		// check the row.
		if (!$table->check()) {
			$this->setError($table->getError());
			return false;
		}

		// store the row.
		if (!$table->store()) {
			$this->setError($table->getError());
			return false;
		}

		return true;
	}
}

?>