<?php
/*
* @package		AJAX Register
* @copyright	Copyright (C) 2009-2011 Emir Sakic, http://www.sakic.net. All rights reserved.
* @license		GNU/GPL, see LICENSE.TXT
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This header must not be removed. Additional contributions/changes
* may be added to this header as long as no information is deleted.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

if (!function_exists('jximport')) {
	function jximport($path)
	{
		static $base;

		if (!$base) {
			$base = realpath(dirname(__FILE__));
		}

		if (strpos($path, 'jxtended') === 0) {
			return JLoader::import($path, $base, '');
		} else {
			return JLoader::import($path, null, 'libraries.');
		}
	}
}

if (JRequest::getCmd('task')=='ajax') {
	$username = JRequest::getVar( 'username', '', 'get', 'string' );
	$email = JRequest::getVar( 'email', '', 'get', 'string' );
	$captcha_check = JRequest::getVar( 'captcha_check', 0, 'get', 'int' );
	$captcha_load = JRequest::getVar( 'captcha_load', 0, 'get', 'int' );
	$recaptcha_check = JRequest::getVar( 'recaptcha_check', 0, 'get', 'int' );
	$answer_check = JRequest::getVar( 'answer_check', 0, 'get', 'int' );
	$question_load = JRequest::getVar( 'question_load', 0, 'get', 'int' );
	
	$db =& JFactory::getDBO();
	$ret = '0';
	if ($username!='') {
		// check for existing username
		$query = 'SELECT id'
		. ' FROM #__users '
		. ' WHERE username = ' . $db->Quote($username)
		;
		$db->setQuery( $query );
		$xid = intval( $db->loadResult() );
		if ($xid) {
			$ret = '1';
		} else {
			// check for blocked usernames
			$config	= &JComponentHelper::getParams('com_ajaxregister');
			$blocks_usernames = $config->get('blocks_usernames', '');
			if ($blocks_usernames!='') {
				if (stristr($blocks_usernames,',')) {
					$blocks_usernames = explode(',', $blocks_usernames);
				} else {
					$blocks_usernames = explode("\n", $blocks_usernames);
				}
				foreach($blocks_usernames as $block_username) {
					if (strcasecmp(trim($username), trim($block_username))==0) {
						$ret = '1';
						break;
					}
				}
			}
		}
	} else if ($email!='') {
		// check for existing email
		$query = 'SELECT id'
			. ' FROM #__users '
			. ' WHERE email = '. $db->Quote($email)
			;
		$db->setQuery( $query );
		$xid = intval( $db->loadResult() );
		if ($xid) {
			$ret = '1';
		}
	} else if ($captcha_check) {
		$validate = false;
		// get a CAPTCHA object
		require_once(JPATH_COMPONENT.DS.'libraries'.DS.'captcha'.DS.'captcha.php');
		$captcha = &JXCaptcha::getInstance('image', array(
				'filePath'	=> JPATH_SITE.DS.'tmp'
			)
		);
		// get the list of CAPTCHA tests from the session and verify that they do exist
		$captchas = $mainframe->getUserState('jxcaptcha.captcha');
		if (!empty($captchas)) {
			// get the post fields from the request
			$post = JRequest::get('get');
			// iterate over the CAPTCHA tests from the session to validate them
			foreach ($captchas as $item) {
				// make sure that something was posted for this CAPTCHA test
				if (isset($post[$item['id']])) {
					// validate without cleaning
					if ($captcha->validate($item['id'], $post[$item['id']], false, false)) {
						$validate = true;
					}
				}
			}
		}
		if ($validate) {
			$ret = '1';
		}
	} else if ($captcha_load) {
		$config	= &JComponentHelper::getParams('com_ajaxregister');
		$captcha_format = $config->get('captcha_format', 'png');
		$captcha_width = $config->get('captcha_width', 100);
		$captcha_height = $config->get('captcha_height', 40);
		$captcha_font_min = $config->get('captcha_font_min', 11);
		$captcha_font_max = $config->get('captcha_font_max', 14);
		// build and set the built-in CAPTCHA test
		require_once(JPATH_COMPONENT.DS.'libraries'.DS.'captcha'.DS.'captcha.php');
		$captcha = &JXCaptcha::getInstance('image', array(
				'filePath'	=> JPATH_SITE.DS.'tmp',
				'format'	=> $captcha_format,
				'width'		=> $captcha_width,
				'height'	=> $captcha_height,
				'minFont'	=> $captcha_font_min,
				'maxFont'	=> $captcha_font_max
			)
		);
		// Initialize the captcha object
		if (!$captcha->test() || !$captcha->initialize()) {
			// either the test failed or the object could not initialize, raise an error and return
			$ret = $captcha->getError();
		}
		// create a CAPTCHA test and set the object into the view
		$captcha->clean();
		if (is_array($return = $captcha->create())) {
			$ret = $return['id'];
		}
	} else if ($recaptcha_check) {
		$config	= &JComponentHelper::getParams('com_ajaxregister');
		// get a reCAPTCHA object
		require_once(JPATH_COMPONENT.DS.'libraries'.DS.'captcha'.DS.'recaptcha.php');
		$recaptcha = JXRecaptcha::getInstance();

		// set the API keys for reCAPTCHA
		$recaptcha->setKeyPair($config->get('recaptcha_public'), $config->get('recaptcha_private'));

		// validate the captcha
		if ($recaptcha->checkCaptcha()) {
			$ret = '1';
			// save to a session
			$challenge = JRequest::getVar('recaptcha_challenge_field', null);
			$user =& JFactory::getUser();
			$user->set($challenge, 1);
		}
	} else if ($answer_check) {
		$config	= &JComponentHelper::getParams('com_ajaxregister');
		
		for ($i=1; $i<=5; $i++) {
			$response = JRequest::getString('answer_'.$i);
			if ($response) {
				$question_id = $i;
				break;
			}
		}
		$challenge = $config->get('answer_'.$question_id, '');

		// validate the captcha
		if (strtolower(trim($challenge)) == strtolower(trim($response))) {
			$ret = '1';
		}
	} else if ($question_load) {
		$config	= &JComponentHelper::getParams('com_ajaxregister');
		$question = array();
		$question['id'] = rand(1,5);
		$question['text'] = $config->get('question_'.$question['id'], '');
		$ret = json_encode($question);
	}
	echo $ret;
	die();
} else {
	// Require the base controller
	require_once (JPATH_COMPONENT.DS.'controller.php');

	// Create the controller
	$controller = new UserControllerExt();

	// Perform the Request task
	$controller->execute( JRequest::getCmd('task') );

	// Redirect if set by the controller
	$controller->redirect();
}
?>