<?php
/*
* @package		AJAX Register
* @copyright	Copyright (C) 2009-2010 Emir Sakic, http://www.sakic.net. All rights reserved.
* @license		GNU/GPL, see LICENSE.TXT
*
* This program is free software; you can redistribute it and/or modify it
* under the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
* 
* This header must not be removed. Additional contributions/changes
* may be added to this header as long as no information is deleted.
*/

class JSiteExt extends JSite
{
	/**
	* Dispatch the application
	*
	* @access public
	*/
	function dispatch($component)
	{

		$document	=& JFactory::getDocument();
		$user		=& JFactory::getUser();
		$router     =& $this->getRouter();
		$params     =& $this->getParams();
		
		// override
		$task = JRequest::getCmd('task');
		$view = JRequest::getCmd('view');
		if ((($task=='register' || $view=='register' || $task=='register_save' || $task=='activate') && !$user->get('id')) || $task=='ajax') {
			$component = 'com_ajaxregister';
		}

		switch($document->getType())
		{
			case 'html':
			{
				//set metadata
				$document->setMetaData( 'keywords', $this->getCfg('MetaKeys') );

				if ( $user->get('id') ) {
					$document->addScript( JURI::root(true).'/includes/js/joomla.javascript.js');
				}

				if($router->getMode() == JROUTER_MODE_SEF) {
					$document->setBase(JURI::current());
				}
			} break;

			case 'feed':
			{
				$document->setBase(JURI::current());
			} break;

			default: break;
		}

		$document->setTitle( $params->get('page_title') );
		$document->setDescription( $params->get('page_description') );

		//$contents = JComponentHelper::renderComponent($component);
		require_once( dirname(realpath (__FILE__)).DS.'helper.php' );
		$contents = JComponentHelperExt::renderComponent($component);
		$document->setBuffer( $contents, 'component');
	}
}
?>